function Y = H2644x4(X,QP,Vi4,Si4,Sf4,Cf4);
%
% H.264 integer 4x4 orthogonal transform.
%   See Iain Richardson 2ed Ch. 7 for the mathematical details.
%   >>> MUST call [Cf4, Ci4, Sf4, Si4, Vi4] = H2644x4Setup FIRST
%       to set up the matrices that do NOT depend on QP.

%mod Vi4 matrix to give us different QP Vi matrices
Vi = Vi4(:,:,mod(QP,6)+1)*2^(floor(QP/6));

%forward scaling factor Mf for QP
Mf = round(((Si4.*Sf4*(2^21))./Vi)); %index array

%[Cf8*X*Cf8T].*Mf*1/2^22
Y =  round((Cf4*X*Cf4.').*Mf*1/(2^15));%index array
