%
% ShowR44
%
% Show Y frames and 4x4 MC residual frames side-by-side
%
%   Read the sequence, get the Y component
%   Read in the residuals
%   Loop on frames and display side-by-side
%      the "stretch" is on a frame-by-frame basis, not global
%
%
% Setup to choose video sequence
%
clear;
%--- FOREMAN -------------------------
%videoSequence = 'foreman_cif.yuv';
%width  = 352;
%height = 288;
%nFrame = 300;
%
%InFileR = 'foreR44';
%--- NEWS ----------------------------
%videoSequence = 'news_cif.yuv';
%width  = 352;
%height = 288;
%nFrame = 300;
%
%InFileR = 'newsR44';
%videoSequence = 'stefan_cif.yuv';
%width  = 352;
%height = 288;
%nFrame = 90;
%
%InFileR = 'stefanR44';
%--- TEMPETE -------------------------
videoSequence = 'tempete_cif.yuv';
width  = 352;
height = 288;
nFrame = 260;

InFileR = 'tempeteR44';

%
% Read the video sequence, get the Y component
%
[Y,U,V] = yuvRead(videoSequence, width, height ,nFrame);
Yf = double(Y);

%
% Read in the residuals
%
load(InFileR,'R');

%
% Display global statistics on console
%
disp(['Max R = ' num2str(max(R(:)))]);
disp(['Ave R = ' num2str(mean(R(:)))]);
disp(['Med R = ' num2str(median(R(:)))]);
disp(['Min R = ' num2str(min(R(:)))]);
%disp(['Std R = ' num2str(sqrt(var(R(:))))]);
disp('any key...');
pause;

%
% Loop over frames, display Y and R side by side
%
figure(1);

for iFrame = 1:nFrame
  Yframe = stretch(Yf(:,:,iFrame));
  Rframe = stretch(R(:,:,iFrame));
  subplot(1,2,1);image(Yframe);colormap(gray(256));axis('image','off');
  title(['frame #',num2str(iFrame)]);
  subplot(1,2,2);image(Rframe);colormap(gray(256));axis('image','off');
  disp('any key...');
  pause;
end 

