function H = hot44N2(x,B2);
%
% INTEGER 2D nonseparable 4x4 REAL Hirschman transform.
%
% H = hot44N2(x,B2);
% Input: x is a 4x4 REAL matrix containing the input image block
%        B2 is the transform matrix times sqrt(2) (all entries 0 or +/- 1)
%           B2 is size 16x16
% Output: H is the integer Hirschman transform

% vectorize the input block
xv = reshape(x,[16,1]);
Hv = B2 * xv;
H = reshape(Hv,[4,4]);
