function H = hot44S2(x,B2);
%
% INTEGER 2D separable 4x4 REAL Hirschman transform.
%
% H = hot44S2(x,B2);
% Input: x is a 4x4 REAL matrix containing the input image block
%        B2 is the transform matrix times sqrt(2) (all entries 0 or +/- 1)
% Output: H is the integer Hirschman transform

H = B2 * x * B2;
