function Z = iH2644x4(Y,QP,Vi4,Ci4);
%
% H.264 integer 4x4 orthogonal inverse transform.
%   See Iain Richardson 2ed Ch. 7 for the mathematical details.
%   >>> MUST call [Cf4, Ci4, Sf4, Si4, Vi4] = H2644x4Setup FIRST
%       to set up the matrices that do NOT depend on QP.
% MADE by copying DCT8x8-1-Neima.m by Neima Arian.
%

%mod Vi4 matrix to give us different QP Vi matrices
Vi = Vi4(:,:,mod(QP,6)+1)*2^(floor(QP/6));

Z = round((Ci4.')*(Y.*Vi)*(Ci4)*1/(2^6));
