function X = ihot44N2(H,B2);
%
% INTEGER 2D nonseparable 4x4 REAL inverse Hirschman transform.
%
% X = ihot44N2(H,B2);
% Input: H is a 4x4 REAL matrix containing the Hirschman transform coefficients
%        B2 is the transform matrix times sqrt(2) (all entries 0 or +/- 1)
%           B2 is size 16x16
% Output: X is the block of pixel values obtained by inverse Hirschman transform

% vectorize the input block
Hv = reshape(H,[16,1]);
Xv = (B2 * Hv)/2;
X = reshape(Xv,[4,4]);
