function X = ihot44S2(H,B2);
%
% INTEGER 2D separable 4x4 REAL inverse Hirschman transform.
%
% X = ihot44S2(H,B2);
% Input: H is a 4x4 REAL matrix containing the Hirschman transform coefficients
%        B2 is the transform matrix times sqrt(2) (all entries 0 or +/- 1)
% Output: X is the block of pixel values obtained by inverse Hirschman transform

X = (B2 * H * B2)/4;
